iOS 4.3 App Rejected

Discussion in 'iOS Development' started by glenwn, Mar 24, 2011.

  1. Ostwind

    Ostwind

    Member

    Joined:
    Mar 22, 2011
    Messages:
    746
    Revert to 4.2 SDK while waiting for a resolution. You can find the download from previous posts.
  2. zaba

    zaba

    Member

    Joined:
    Jan 29, 2011
    Messages:
    1
    Tried reverting to 4.2 but I got rejected, it did not generate a crash log for apple but crashed, and was rejected still,
    :(
  3. mindlube

    mindlube

    Member

    Joined:
    Oct 3, 2008
    Messages:
    993
    @Zaba, I would assume that your app failed for some other reason (null variable references, most commonly). Because I bet many devs have submitted apps compiled with SDK 4.2 + XCode 3.2.5. Make sure you are using the Xcode that comes with SDK 4.2, as described by mantasp.
  4. rainbow_lazer

    rainbow_lazer

    New Member

    Joined:
    Mar 16, 2011
    Messages:
    5
    This is a very frustrating problem, but I'm happy to come across this thread. Like other posters, I've tested and tested on multiple generations of iPhones/Pads/Pods and things run great, but Apple rejects it as detailed in the crash log below.

    Maybe I'm just lacking expertise, but the stack trace information in the crash log may as well be in Greek :) At any rate, this would be much less frustrating if it were reproducible on my end.

    For now, I'm going to try the recommended workaround of downloading XCode 3.2.5/SDK 4.2, set 4.2 as the target, rebuild and resubmit.



    Update:

    I also contacted Apple Developer Technical Support about this problem, namely the fact that I can't reproduce the crashes on any of my test devices. Here's Apple's advice:
    Last edited: May 2, 2011
  5. Ferazel

    Ferazel

    Member

    Joined:
    Apr 18, 2010
    Messages:
    181
    Confirmed that resubmitting the App with 4.2 and XCode 3.2.5 worked and the app was approved.
  6. hippocoder

    hippocoder

    Digital Ape Moderator

    Joined:
    Apr 11, 2010
    Messages:
    11,043
    Can those who had approve apps specify if they used universial builds or not (arm6 + 7) as this may be a major contributing cause.
  7. Ferazel

    Ferazel

    Member

    Joined:
    Apr 18, 2010
    Messages:
    181
    We submitted this originally as an Arm7 only then our second submission we submitted as a arm6+arm7 when we built under SDK 4.2.
  8. Mark Sweeney

    Mark Sweeney

    Member

    Joined:
    Feb 21, 2010
    Messages:
    106
    My app was built with 4.2 Xcode 3.2.5, arm6+arm7, accepted two days ago.
  9. Digitalvanilla

    Digitalvanilla

    New Member

    Joined:
    May 2, 2011
    Messages:
    2
    After one month (!!!) of research I came across this forum (thanks to the help of an Apple Engineer) and after had my app rejected thousand of times, finally I used XCode 3.2.5 and the app in Distribution build has been accepted.
    Now I have to use XCode 4 (of course technology moves on and we have to do the same), so my question is:

    How far is the next version of Unity3D that fix this problem and its compatible with XCode 4?


    The problem relay in the FMOD. Al the crash logs points there.

    A happy user of Unity 3D
  10. Dreamora

    Dreamora

    Member

    Joined:
    Apr 5, 2008
    Messages:
    26,586
    how comes you used unity and didn't consider checking the unity boards first ... :)
  11. randyherring

    randyherring

    New Member

    Joined:
    Feb 9, 2008
    Messages:
    42
    How come Unity has not sent a notice to all of us that have an iPhone license?

    Don't get me wrong, I love using Unity and I think the company is doing a wonderful job with their software. But as a paying customer, I would have like to have been told that there was a known issue that causes Unity to fail on submission for iOS 4.3.
  12. gambit

    gambit

    New Member

    Joined:
    Dec 26, 2010
    Messages:
    57
    Has there been any issues with Xcode 3.2.6 ? or will apple accept apps made with unity using Xcode 3.2.6.
  13. Mantas Puida

    Mantas Puida

    Unity Technologies

    Joined:
    Nov 13, 2008
    Messages:
    1,254
    Xcode 3.2.6 comes with SDK 4.3 so it won't work.
  14. gambit

    gambit

    New Member

    Joined:
    Dec 26, 2010
    Messages:
    57
    Hmmm well guess i will keep playing around till someone fixes it. i don't plan on putting anything on the apple store for a while, so hopefully it will be fixed by then.
  15. Diego

    Diego

    New Member

    Joined:
    Jul 30, 2008
    Messages:
    58
    +1

    It would be nice to have a Unity official communication about this.
  16. technicat

    technicat

    Member

    Joined:
    Nov 22, 2006
    Messages:
    1,070
    At least, this topic should be made sticky, until it's resolved.
  17. Gigiwoo

    Gigiwoo

    Member

    Joined:
    Mar 16, 2011
    Messages:
    1,723
    Agree!!!
  18. Digitalvanilla

    Digitalvanilla

    New Member

    Joined:
    May 2, 2011
    Messages:
    2
    I didnt check in the forums because I thought that the problem was on XCode side, means my fault!!!!!
    Which it wasn't! :mad::mad:
  19. squidbot

    squidbot

    Member

    Joined:
    Jan 4, 2011
    Messages:
    126
    I'm guessing everyone else just got the e-mail... it just showed up in my inbox. Hope this is resolved before I want to ship... I took the Xcode 4 plunge and don't want to have to go back.
  20. Navinfo

    Navinfo

    New Member

    Joined:
    May 3, 2011
    Messages:
    3
    4 of our new apps have been waiting for 1 month or more, because of the Unity doesn't solve the compatibility with iOS 4.3.
    This delay it's a big loss for all of developers. Wasted time in spinning market.
    It'll be correct at least if Unity says a date when this problem will be solved.
  21. htsoft

    htsoft

    Member

    Joined:
    May 3, 2011
    Messages:
    6
    Could it be that the problem is in the use of LLVM instead of GCC compiler?
  22. BasketQase

    BasketQase

    New Member

    Joined:
    Sep 12, 2005
    Messages:
    97
    We've built both Optimized (arm7) and Standard (arm6 arm7) apps and had both accepted to the app store after downgrading to SDK 4.2.
  23. hippocoder

    hippocoder

    Digital Ape Moderator

    Joined:
    Apr 11, 2010
    Messages:
    11,043
    What is stopping you from installing 3.2.5 and then shipping your products. There is nothing in 4, which isn't available in 3.2.5.
  24. ratrodstudio

    ratrodstudio

    Member

    Joined:
    Apr 3, 2009
    Messages:
    211
    Just a note, our App got approved today. We built using Xcode 3.2.6 SDK 4.3. The build is universal for iPhone iPad. It was approved on the first submission without any problems.

    Maybe the issues are due to Xcode4 with SDK 4.3? or maybe Apple resolved the problems.
  25. Mantas Puida

    Mantas Puida

    Unity Technologies

    Joined:
    Nov 13, 2008
    Messages:
    1,254
    These are interesting news. Have you done any custom changes to the Xcode project before submitting application?
  26. ratrodstudio

    ratrodstudio

    Member

    Joined:
    Apr 3, 2009
    Messages:
    211
    No custom changes in settings. I only changed AppController.mm to Event Pump based and disabled the Accelerometer 0.0.

    I also changed USE_OPENGLES20 to 0.
    Last edited: May 5, 2011
  27. mindlube

    mindlube

    Member

    Joined:
    Oct 3, 2008
    Messages:
    993
    @RatRod, thanks for reporting! I am going assume that we can go forward using SDK 4.3 and XCode 3.2.6, until any contrary reports, or more announcements from Unity.
  28. ratrodstudio

    ratrodstudio

    Member

    Joined:
    Apr 3, 2009
    Messages:
    211
    I provided my Xcode project to the Unity Team so they can analyze it. Maybe Apple's crashes are due to OPENGLES20? I had it disabled, which is the only change that could make a difference. If it's not that, then maybe its only crashing with the Xcode 4 version.

    We should get more updates soon and some announcements.
  29. susantio

    susantio

    New Member

    Joined:
    Jul 14, 2009
    Messages:
    97
    HI just want to confirm that our apps also got approved using Xcode 3.2.6 SDK 4.3.
  30. Mantas Puida

    Mantas Puida

    Unity Technologies

    Joined:
    Nov 13, 2008
    Messages:
    1,254
    Could you please submit your Xcode project as bug report for investigation? It really would help us.
    Thanks!
  31. mda7

    mda7

    New Member

    Joined:
    Aug 18, 2010
    Messages:
    6
    Question for the people who downgraded to SDK4.2, and xCode 3.2.5 and submitted successfully to the App Store. How did you go about the downgrade? Did you just download and install or did you need to first remove \ uninstall xCode4.x and IOS 4.3?
  32. jcbadboy

    jcbadboy

    Member

    Joined:
    Mar 24, 2010
    Messages:
    13

    I uninstalled the xcode 3.2.5 SDK 4.3 and reinstalled the SDK 4.2 version. I removed all profiles to, and reinstall him again.

    The only issue i have seem was with profiles. Resolved with reinstalation.

    Now, after a month and a half, my first app in app store was finally accepted.

    http://itunes.apple.com/us/app/energized-dice/id428138345?mt=8

    hope that helps.
  33. Grumps87

    Grumps87

    New Member

    Joined:
    Oct 3, 2010
    Messages:
    4
    Did you use the similar setting with Radrodstudio? I did not get rejected but after reading through these 7 pages, I decided to downgrade to 3.2.5 anyway just to be sure.
  34. svenskefan

    svenskefan

    Member

    Joined:
    Nov 26, 2008
    Messages:
    282
    Just a heads up to ratrodstudio and susantio. Have you actually downloaded your own app from the appstore and run it on the device?
    The reason I am asking is we got our app approved, (using 4.3) but it was crashing badly on launch.....
  35. ratrodstudio

    ratrodstudio

    Member

    Joined:
    Apr 3, 2009
    Messages:
    211
    Yes, it's working fine and I assume it does for our customers too. The game is in the Top 5 in Sports here in Canada. The rating average is 4.5 - 5 stars so far. From my past experience, if people would get any crashes I would be noticed pretty quick in the reviews.

    Did you used 3.2.6 or Xcode 4? Also do you have OpenGLES 2.0 enabled?
  36. kenlem

    kenlem

    Member

    Joined:
    Oct 16, 2008
    Messages:
    1,451
    I'm having trouble with the download link. It starts the download but then end quickly and I get a tiny corrupted file.
  37. susantio

    susantio

    New Member

    Joined:
    Jul 14, 2009
    Messages:
    97
    mantasp: We're sending the build now as a bug report.

    Grumps87 and svenskefan: I'm not sure what build setting ratrodstudio uses. we just used xcode 3.2.6 and sdk 4.3. I tested the game and even had a friend download it and it worked fine on both of our device. which is iphone 3GS

    edit: the target platform was universal armv6 + armv7 if that helps.
    Last edited: May 11, 2011
  38. gigaplay

    gigaplay

    New Member

    Joined:
    Feb 11, 2007
    Messages:
    15
    If you downgrade to XCode 3.2.5 and SDK 4.2, you'll need to reinstall Application Tools 1.1 if you want to process Unity-created desktop apps to submit to the Mac App Store. The thing is, Apple appears to have removed Application Tools 1.1 from their Dev website.

    Or am I just not looking hard enough?
  39. psyclone

    psyclone

    Member

    Joined:
    Nov 17, 2009
    Messages:
    245
    I resubmitted my apps after downgrading to 3.2.6 and 4.3 as quoted, but got a Rejected due to crashing.


    Any progress from Unity Tech in solving these issues...
  40. mindlube

    mindlube

    Member

    Joined:
    Oct 3, 2008
    Messages:
    993
    Also, if anyone is frequently changing XCode versions, what I do is from the terminal:
    sudo /Developer/Library/uninstall-devtools --mode=all
    then reboot install the other version
  41. Mantas Puida

    Mantas Puida

    Unity Technologies

    Joined:
    Nov 13, 2008
    Messages:
    1,254
    We suggested to downgrade down to Xcode 3.2.5 + 4.2 SDK (NOT! 3.2.6+4.3).
  42. Grumps87

    Grumps87

    New Member

    Joined:
    Oct 3, 2010
    Messages:
    4
    Application Loader is actually bundled up with the Xcode 3.2.5. You must have deselected it in the install options.


    Submission with Xcode 3.2.5 + 4.2 SDK was successful.
  43. catacomber

    catacomber

    Member

    Joined:
    Sep 22, 2009
    Messages:
    488
    Hi, could you tell me if it's possible to have both the latest Xcode version (which I have) and Xcode 3.2.5 (which I have in my old downloads file) installed at the same time? And if you can have both installed, where do you put Xcode 3.2.5--thanks for any help.
  44. Mantas Puida

    Mantas Puida

    Unity Technologies

    Joined:
    Nov 13, 2008
    Messages:
    1,254
    Hello Everyone,

    Thanks to susantio and ratrodstudio we have some bits of news to share. Few posts above they reported about successful submission to the App Store using iOS SDK 4.3. Our investigation of their projects revealed common use of special linker flag "-all_load" (which is required by some 3rd party ObjC plugins). We submitted couple of our applications (built using iOS SDK 4.3 and "-all_load" flag) to the App Store and they were successfully approved. We still are quite reserved about this finding. It might be just coincidence or might work only on some subset of applications, but if you are eager to test it we are very interested to get your feedback.

    Instructions how to add this flag to your release build when using Xcode 3.2.6 (SDK 4.3):
    1. Open your project in Xcode.
    2. In Xcode menu select Project->Edit Active Target
    3. In Configuration drop down select "Release"
    4. In Search field type "linker"
    5. Find the field named "Other Linker Flags" and doubleclick on it.
    [​IMG]
    6. Click "+" and add "-all_load".
    [​IMG]
    7. Clean all targets.
    8. Make a distribution build.

    Instructions how to add this flag to your release build when using Xcode 4 (SDK 4.3):
    1. Open your project in Xcode.
    2. In Project Navigator click on your project
    3. On next pane select "Unity-iPhone" under TARGETS.
    4. On next pane select "Build Settings"
    5. In Search field type "linker"
    6. Find the field named "Other Linker Flags" and doubleclick on "Release" configuration near it.
    [​IMG]
    7. Click "+" and add "-all_load".
    [​IMG]
    8. Clean all targets.
    9. Make a distribution build.

    We will continue our research on this problem and as soon as we are confident about the solution we will release Unity update.
  45. JGeorge

    JGeorge

    Member

    Joined:
    Dec 14, 2010
    Messages:
    30
    Ty mantas, any update on using XCode 4 for the games?
  46. Mantas Puida

    Mantas Puida

    Unity Technologies

    Joined:
    Nov 13, 2008
    Messages:
    1,254
    Ehm... My previous post includes instructions for Xcode 4 too :)
  47. JGeorge

    JGeorge

    Member

    Joined:
    Dec 14, 2010
    Messages:
    30
    Wow, sorry, just skimmed the post this morning!
  48. jrdata2k

    jrdata2k

    Member

    Joined:
    Oct 6, 2008
    Messages:
    27
    Got my fingers crossed for unity iOS team!!




    ^^ plus now I can subscribe to this thread to keep up with the progress ;)
  49. GarryJay

    GarryJay

    New Member

    Joined:
    Nov 23, 2009
    Messages:
    42
    dito jrdata2k :) and yeah, go team unity, go.
    Eagerly waiting for a fix, well not really, just make it good. Better waiting another day and have a good fix, then a quick fix that kind of sucks.
  50. Lowa

    Lowa

    New Member

    Joined:
    Oct 28, 2008
    Messages:
    11
    Hi, sorry but i have follow the istruction but my app crash immediate and xcode print

    Unity-iPhone has exited with status 1.

    have yu any ideas???? :-(

    Good work!

    Lowa